import examplebeans.Cat;

import java.lang.reflect.Field;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

public class NewDBFetchTest<T> {
    Class<T> clazz;

    public NewDBFetchTest(Class<T> clazz) {
        this.clazz = clazz;
    }

    private T getObjectFromDatabase(/*ResultSet resultSet*/) {
        T object;
        try {
            List<List<String>> classFieldTypeLists = new ArrayList<>();
            for (Class<?> c = clazz; c != null; c = c.getSuperclass()) {
                List<String> fieldTypeList = new ArrayList<>();
                Field[] declaredFields = c.getDeclaredFields();
                for (Field declaredField : declaredFields) {
                    fieldTypeList.add(declaredField.getType().getName());
                }
                classFieldTypeLists.add(fieldTypeList);
            }

            { // DEBUG
                System.out.println("1: ------------------------------");
                for (List<String> strList : classFieldTypeLists) {
                    for (String str : strList) {
                        System.out.println(str);
                    }
                }
            } // DEBUG

            List<String> finalFieldTypeList = new ArrayList<>();
            for (int i = classFieldTypeLists.size() - 1; i >= 0; i--) {
                finalFieldTypeList.addAll(classFieldTypeLists.get(i));
            }

            { //DEBUG
                System.out.println("2: ------------------------------");
                for (String str : finalFieldTypeList) {
                    System.out.println(str);
                }
            } // DEBUG

            object = null;
        } catch (final Exception e) {
            System.out.println("Error parsing object from database result");
            e.printStackTrace();
            object = null;
        }
        return object;
    }

    public static void main(String[] args) {

        for (int i = 0; i < 10; i++) {
            System.out.println(i);
        }

    }
}
