import examplebeans.Cat;
import tech.nevets.osql4j.ClassUtils;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ReflectionTest {

    public static void main(String[] args) throws NoSuchMethodException, InvocationTargetException, InstantiationException, IllegalAccessException, ClassNotFoundException {
        List<Class<?>> classList = List.of(
                ClassUtils.forName("java.lang.String"),
                ClassUtils.forName("int"),
                ClassUtils.forName("java.lang.String"),
                ClassUtils.forName("java.math.BigDecimal"),
                ClassUtils.forName("boolean")
        );
        Class<?>[] classArray = new Class[classList.size()];
        for (int i = 0; i < classList.size(); i++) {
            classArray[i] = classList.get(i);
        }

        Constructor<Cat> catConstructor = Cat.class.getConstructor(classArray);

        Cat cat = catConstructor.newInstance(
                "name",
                12,
                "brown",
                BigDecimal.valueOf(12.42),
                false
        );

        System.out.println(cat);
    }
}
